
// ---------------------------------------------------------------------------------------------------------------------
// BMC Remedy Action Request (AR) System parameters
// ---------------------------------------------------------------------------------------------------------------------
var PROTOCOL = "http";
var REMEDY_SERVER_HOSTNAME = "<Remedy Server URL that can be resolved to an IP address. e.g., www.example.com or my-remedy-server>";
var REMEDY_SERVER_PORT = "8080";
var REMEDY_AR_SERVER_NAME = "<Remedy AR Server Name. e.g., ARServer>";
var REMEDY_API_PORT = "8443";

var XMATTERS_COMPANY_NAME = "<Your Company Name>";

//----------------------------------------------------------------------------------------------------
// URL used to retrieve information from Remedy AR/Change Management System
//----------------------------------------------------------------------------------------------------
var REMEDY_API_TOKEN_PATH = "https://" + REMEDY_SERVER_HOSTNAME + ":" + REMEDY_API_PORT + "/api/jwt/login";
var REMEDY_API_BASE_PATH  = "https://" + REMEDY_SERVER_HOSTNAME + ":" + REMEDY_API_PORT + "/api/arsys/v1/entry/";

var XM_CHG_INFRASTRUCTURE_CHANGE_WS_URL      = PROTOCOL + "://" + REMEDY_SERVER_HOSTNAME + ":" + REMEDY_SERVER_PORT + "/arsys/services/ARService?server=" + REMEDY_AR_SERVER_NAME + "&webService=XM_CHG_InfrastructureChange_WS";
var XM_CHG_CHANGE_INTERFACE_WS_URL           = PROTOCOL + "://" + REMEDY_SERVER_HOSTNAME + ":" + REMEDY_SERVER_PORT + "/arsys/services/ARService?server=" + REMEDY_AR_SERVER_NAME + "&webService=XM_CHG_ChangeInterface_WS";
var XM_CHG_CHANGE_AP_DETAIL_SIGNATURE_WS_URL = PROTOCOL + "://" + REMEDY_SERVER_HOSTNAME + ":" + REMEDY_SERVER_PORT + "/arsys/services/ARService?server=" + REMEDY_AR_SERVER_NAME + "&webService=XM_CHG_ChangeAPDetailSignature_WS";

var XM_CHG_CHANGE_AP_DETAIL_SIGNATURE_WS_GET_APPROVAL_BY_ID_QUALIFICATION                  = "\'Request ID\' = \"${REQUEST_ID}\" AND \'Approval Status2\' != \"Approved\"";
var XM_CHG_CHANGE_AP_DETAIL_SIGNATURE_WS_GET_APPROVAL_BY_REQUEST_ID_QUALIFICATION          = "\'Request ID\' = \"${REQUEST_ID}\"";
var XM_CHG_CHANGE_AP_DETAIL_SIGNATURE_WS_GET_CLOSED_APPROVALS_BY_APPROVAL_ID_QUALIFICATION = "\'Approval ID\' = \"${APPROVAL_ID}\" AND \'Approval Status2\' = \"Closed\"";

// The "Host" header value which will be sent for the HTTP WS POST to the Remedy Midtier Server
var HOST_HEADER = REMEDY_SERVER_HOSTNAME;

//----------------------------------------------------------------------------------------------------
// The location and authentication credentials for the Remedy REST API. The user's
// password should be encrypted using the iapassword.sh utility.
//----------------------------------------------------------------------------------------------------
var REMEDY_WS_USERNAME = "xmchange";
var REMEDY_WS_PASSWORD_FILE = "conf/xm_chg_ws.pwd";
var REMEDY_WS_PASSWORD = getPassword(REMEDY_WS_PASSWORD_FILE);

//----------------------------------------------------------------------------------------------------
// URL of inbound integration used to handle incoming events
//----------------------------------------------------------------------------------------------------
var XMATTERS_REMEDY_CHANGE_APPROVAL_URL = "<URL of Change Approval inbound integration>";

// UUIDs for the response options
var RESPONSE_OPTIONS = {
  "APPROVE"     : "<Insert Approve response option UUID here>",     // Approve response option identifier
  "REJECT"      : "<Insert Reject response option UUID here>",      // Reject response option identifier
  "HOLD"        : "<Insert Hold response option UUID here>",        // Hold response option identifier
  "VIEW_CHANGE" : "<Insert View Change response option UUID here>"  // View Change response option identifier
};

//----------------------------------------------------------------------------------------------------
// The credentials of the xMatters user to use when authenticating requests to xMatters. The user's
// password should be encrypted using the iapassword.sh utility. .
//----------------------------------------------------------------------------------------------------
var INITIATOR = "remedychange";
var PASSWORD = "conf/.initiatorpasswd";

// ----------------------------------------------------------------------------------------------------
// Filter to use in <IAHOME>/conf/deduplicator-filter.xml
// ----------------------------------------------------------------------------------------------------
var DEDUPLICATION_FILTER_NAME = "bmcremedychange" + INTEGRATION_VERSION_NUMBER;

// ----------------------------------------------------------------------------------------------------
// Integration configuration
// ----------------------------------------------------------------------------------------------------
// If false, the response handler will suppress callout annotations from xMatters
var ANNOTATE_DELIVERY = true;
var DELETE_EXISTING_EVENTS = true;
var TIME_TO_SLEEP_BEFORE_PROCESSING_DEL_FOR_REJECTED_APPOVALS = 2000;  // time in milliseconds

// Set this to false if you want to send and create both CHANGE event and APPROVAL event.
var SEND_ACTIVE_APPROVAL_ONLY = true;

var WORK_INFO_TYPE = "General Information";
var WORK_INFO_VIEW_ACCESS = "Internal";
var WORK_INFO_LOCKED = "Yes";
var WORK_INFO_SUMMARY_FIELD_LENGTH = 100;

// The change manager and coordinator will only be sent notifications whose Alert Status match the lists below
// If you want to send notifications to either the Change Manager or Coordinator regardless of the Alert Status set the lists to = null
// EX: var CHANGE_COORDINATOR_ALERT_STATUS = null;
var CHANGE_COORDINATOR_ALERT_STATUS = ["Cancelled", "Closed", "Completed", "Draft", "Implementation In Progress", "Pending", "Planning In Progress", "Rejected", "Request For Authorization", "Request For Change", "Scheduled", "Scheduled For Approval", "Scheduled For Review" ];
var CHANGE_MANAGER_ALERT_STATUS =  ["Cancelled", "Closed", "Completed", "Draft", "Implementation In Progress", "Pending", "Planning In Progress", "Rejected", "Request For Authorization", "Request For Change", "Scheduled", "Scheduled For Approval", "Scheduled For Review" ];

var CHANGE_COORDINATOR_LOGIN_FIELD = "aslogid";
var CHANGE_MANAGER_LOGIN_FIELD = "cab_manager_login";

// Annotation to be used for prefix within BMC Remedy Change
var NOTE_PREFIX = "[xMatters] - ";

// Response Change Request - Prefix used in worklog
var CHANGE_REQUEST_APPROVED       = "Approved by ";
var CHANGE_REQUEST_REJECTED       = "Rejected by ";
var CHANGE_REQUEST_HOLD           = "Hold set by ";
var CHANGE_REQUEST_VIEW_CHANGE    = " viewed the change request";
var CHANGE_REQUEST_ANNOTATE       = "Annotated by ";

// =====================================================================================================================
// Global variables
// =====================================================================================================================

/**
 * A global logger for any js files that aren't class definitions using WSUtil as a super-class
 */
var log = new Logger("BMC Remedy Change: ");

var REQUEST_ACTION_DELETE = "delete";

var REQUEST_TYPE_CHANGE = "change";
var REQUEST_TYPE_APPROVAL = "approval";
var REQUEST_TYPE_DELETE_APPROVAL = "deleteapproval";

var CHANGE_ACTION_MODIFY = "MODIFY";

var RESPONSE_ACTION_APPROVED = "APPROVED";
var RESPONSE_ACTION_APPROVE = "APPROVE";
var RESPONSE_ACTION_REJECTED = "REJECTED";
var RESPONSE_ACTION_REJECT = "REJECT";
var RESPONSE_ACTION_HOLD = "HOLD";
var RESPONSE_ACTION_VIEW_CHANGE = "VIEW CHANGE";
var RESPONSE_ACTION_ANNOTATE = "ANNOTATE";

// Set to true to enable lookup; false to disable.
var ALTERNATE_APPROVERS_LOOKUP = true;

// Enable logging - logNotification (default: false).
var LOGGING_ENABLED = true;




