/**
 * ---------------------------------------------------------------------------------------------------------------------
 * setChangeWorkLog
 *
 * set the fields in the change associated with the annotations from the user and xMatters, dependant on the value
 * of addResponseAnnotations
 *
 * ---------------------------------------------------------------------------------------------------------------------
 */
function setChangeWorkLog(change, addResponseAnnotations, summary, notes)
{
    log.debug("Enter - setChangeWorkLog");
    log.info("setChangeWorkLog - summary [" + summary + "], notes [" + notes + "]");

    if (addResponseAnnotations)
    {
        if (!isEmpty(summary) || !isEmpty(notes))
        {
            change.Action = CHANGE_ACTION_MODIFY;

            change.Work_Info_Type = WORK_INFO_TYPE;
            change.Work_Info_Locked = WORK_INFO_LOCKED;
            change.Work_Info_View_Access = WORK_INFO_VIEW_ACCESS;

            if (!isEmpty(summary))
            {
                change.Work_Info_Summary = summary; // limited char field in Remedy (default: 100)
		        change.Work_Info_Notes = summary + ". "
            }

            if (!isEmpty(notes))
            {
                change.Work_Info_Notes += notes;
            }
        }
    }

    log.debug("Exit - setChangeWorkLog");
}

/**
 * ---------------------------------------------------------------------------------------------------------------------
 * setApproval
 *
 * Set the approval object fields necessary to update a Remedy Approval
 *
 * ---------------------------------------------------------------------------------------------------------------------
 */
function setApproval(approval, newApprovalStatus, xmattersResponderId, annotation)
{
    log.debug("Enter - getApproval");
    log.info("setApproval - new status [" + newApprovalStatus + "] for " + xmattersResponderId + " for approval with request id of " + approval.Infrastructure_Change_ID);

    approval.Approval_Status2 = newApprovalStatus;
    approval.Approver_Signature = xmattersResponderId;

	// add the justification if the approval was rejected
	if (newApprovalStatus.equals("Rejected")) {
	  approval.Justification = annotation;
	} else {
	  approval.Justification = "";
	}

    log.debug("Exit - setApproval");
}
